// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, IconKind};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsIcon")]
    pub struct Icon(Object<ffi::AsIcon, ffi::AsIconClass>);

    match fn {
        type_ => || ffi::as_icon_get_type(),
    }
}

impl Icon {
    pub const NONE: Option<&'static Icon> = None;

    #[doc(alias = "as_icon_new")]
    pub fn new() -> Icon {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_icon_new()) }
    }
}

impl Default for Icon {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Icon>> Sealed for T {}
}

pub trait IconExt: IsA<Icon> + sealed::Sealed + 'static {
    #[doc(alias = "as_icon_get_filename")]
    #[doc(alias = "get_filename")]
    fn filename(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_icon_get_filename(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_icon_get_height")]
    #[doc(alias = "get_height")]
    fn height(&self) -> u32 {
        unsafe { ffi::as_icon_get_height(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_icon_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> IconKind {
        unsafe { from_glib(ffi::as_icon_get_kind(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_icon_get_name")]
    #[doc(alias = "get_name")]
    fn name(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_icon_get_name(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_icon_get_scale")]
    #[doc(alias = "get_scale")]
    fn scale(&self) -> u32 {
        unsafe { ffi::as_icon_get_scale(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_icon_get_url")]
    #[doc(alias = "get_url")]
    fn url(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_icon_get_url(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_icon_get_width")]
    #[doc(alias = "get_width")]
    fn width(&self) -> u32 {
        unsafe { ffi::as_icon_get_width(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_icon_set_filename")]
    fn set_filename(&self, filename: &str) {
        unsafe {
            ffi::as_icon_set_filename(self.as_ref().to_glib_none().0, filename.to_glib_none().0);
        }
    }

    #[doc(alias = "as_icon_set_height")]
    fn set_height(&self, height: u32) {
        unsafe {
            ffi::as_icon_set_height(self.as_ref().to_glib_none().0, height);
        }
    }

    #[doc(alias = "as_icon_set_kind")]
    fn set_kind(&self, kind: IconKind) {
        unsafe {
            ffi::as_icon_set_kind(self.as_ref().to_glib_none().0, kind.into_glib());
        }
    }

    #[doc(alias = "as_icon_set_name")]
    fn set_name(&self, name: &str) {
        unsafe {
            ffi::as_icon_set_name(self.as_ref().to_glib_none().0, name.to_glib_none().0);
        }
    }

    #[doc(alias = "as_icon_set_scale")]
    fn set_scale(&self, scale: u32) {
        unsafe {
            ffi::as_icon_set_scale(self.as_ref().to_glib_none().0, scale);
        }
    }

    #[doc(alias = "as_icon_set_url")]
    fn set_url(&self, url: &str) {
        unsafe {
            ffi::as_icon_set_url(self.as_ref().to_glib_none().0, url.to_glib_none().0);
        }
    }

    #[doc(alias = "as_icon_set_width")]
    fn set_width(&self, width: u32) {
        unsafe {
            ffi::as_icon_set_width(self.as_ref().to_glib_none().0, width);
        }
    }
}

impl<O: IsA<Icon>> IconExt for O {}
